From d542f01091ee893539734386a1a81711d56f104d Mon Sep 17 00:00:00 2001
From: Nicolas ROCHE <nroche@entrouvert.com>
Date: Thu, 1 Dec 2022 18:27:00 +0100
Subject: [PATCH 3/4] toulouse-maelis: add geographic referentials (#71858)

---
 .../data/test_read_country_list.json          |  870 ++
 .../data/test_read_street_list.json           | 9490 +++++++++++++++++
 functests/toulouse_maelis/test_family.py      |    5 +-
 passerelle/contrib/toulouse_maelis/models.py  |   20 +
 .../toulouse_maelis/R_read_country_list.xml   |   30 +
 .../toulouse_maelis/R_read_street_list.xml    |   18 +
 tests/test_toulouse_maelis.py                 |   36 +
 7 files changed, 10467 insertions(+), 2 deletions(-)
 create mode 100644 functests/toulouse_maelis/data/test_read_country_list.json
 create mode 100644 functests/toulouse_maelis/data/test_read_street_list.json
 create mode 100644 tests/data/toulouse_maelis/R_read_country_list.xml
 create mode 100644 tests/data/toulouse_maelis/R_read_street_list.xml

diff --git a/functests/toulouse_maelis/test_family.py b/functests/toulouse_maelis/test_family.py
index d80c570c..d46449f7 100644
--- a/functests/toulouse_maelis/test_family.py
+++ b/functests/toulouse_maelis/test_family.py
@@ -128,25 +128,26 @@ FAMILY_RESET_PAYLOAD = {
 }
 
 
 # @pytest.mark.xfail(run=False)
 @pytest.mark.parametrize(
     "ref",
     [
         'category',
-        'civility',  # 'country', 'county',
+        'civility',
+        'country',
         'csp',
         'dietcode',
         'organ',
         'pai',
         'quality',
         'quotient',
         'situation',
-        # 'street','town',
+        'street',
         'vaccin',
     ],
 )
 def test_referentials(conn, ref):
     url = conn + '/read-%s-list' % ref
     resp = requests.get(url)
     resp.raise_for_status()
     res = resp.json()
diff --git a/passerelle/contrib/toulouse_maelis/models.py b/passerelle/contrib/toulouse_maelis/models.py
index 166669bb..5408053d 100644
--- a/passerelle/contrib/toulouse_maelis/models.py
+++ b/passerelle/contrib/toulouse_maelis/models.py
@@ -90,16 +90,18 @@ class ToulouseMaelis(BaseResource, HTTPResource):
         # remote referentials
         cache_key = 'maelis-%s-%s' % (self.pk, referential_name)
         data = cache.get(cache_key)
         if data is None:
             response = self.call('Family', 'read' + referential_name + 'List')
             data_list = []
             if referential_name == 'Organ':
                 data_list = [{'id': x.id, 'text': x.code} for x in response]
+            elif referential_name == 'Street':
+                data_list = [{'id': x.idStreet, 'text': x.libelleStreet} for x in response]
             else:
                 data_list = [{'id': x.code, 'text': x.libelle} for x in response]
 
             # remove redundant codes from list
             uniq_text = set()
             uniq_data = []
             for item in data_list:
                 item['text'] = item['text'].strip()
@@ -376,16 +378,25 @@ class ToulouseMaelis(BaseResource, HTTPResource):
         display_category='Famille',
         description='Liste des compléments du numéro de voie',
         name='read-complement-list',
         perm='can_access',
     )
     def read_complement_list(self, request):
         return {'data': self.get_referential('Complement')['list']}
 
+    @endpoint(
+        display_category='Famille',
+        description='Liste des pays',
+        name='read-country-list',
+        perm='can_access',
+    )
+    def read_country_list(self, request):
+        return {'data': self.get_referential('Country')['list']}
+
     @endpoint(
         display_category='Famille',
         description='liste des catégories socio-professionnelles',
         name='read-csp-list',
         perm='can_access',
     )
     def read_csp_list(self, request):
         return {'data': self.get_referential('CSP')['list']}
@@ -448,16 +459,25 @@ class ToulouseMaelis(BaseResource, HTTPResource):
         display_category='Famille',
         description='liste des situations',
         name='read-situation-list',
         perm='can_access',
     )
     def read_situation_list(self, request):
         return {'data': self.get_referential('Situation')['list']}
 
+    @endpoint(
+        display_category='Famille',
+        description='liste des voies',
+        name='read-street-list',
+        perm='can_access',
+    )
+    def read_street_list(self, request):
+        return {'data': self.get_referential('Street')['list']}
+
     @endpoint(
         display_category='Famille',
         description='Liste des vaccins',
         name='read-vaccin-list',
         perm='can_access',
     )
     def read_vaccin_list(self, request):
         return {'data': self.get_referential('Vaccin')['list']}
diff --git a/tests/test_toulouse_maelis.py b/tests/test_toulouse_maelis.py
index 256e755a..61053692 100644
--- a/tests/test_toulouse_maelis.py
+++ b/tests/test_toulouse_maelis.py
@@ -42,23 +42,25 @@ FAILED_AUTH = FakedResponse(content=get_xml_file('R_failed_authentication.xml'),
 ISWSRUNNING_TRUE = FakedResponse(content=get_xml_file('R_is_ws_running.xml') % b'true', status_code=200)
 ISWSRUNNING_FALSE = FakedResponse(content=get_xml_file('R_is_ws_running.xml') % b'false', status_code=200)
 READ_FAMILY = FakedResponse(content=get_xml_file('R_read_family.xml'), status_code=200)
 READ_FAMILY_LAX = FakedResponse(content=get_xml_file('R_read_family_relax.xml'), status_code=200)
 READ_FAMILY_ORD = FakedResponse(content=get_xml_file('R_read_family_reordered.xml'), status_code=200)
 READ_RL1_FAMILY = FakedResponse(content=get_xml_file('R_read_family_with_only_rl1.xml'), status_code=200)
 READ_CATEGORIES = FakedResponse(content=get_xml_file('R_read_category_list.xml'), status_code=200)
 READ_CIVILITIES = FakedResponse(content=get_xml_file('R_read_civility_list.xml'), status_code=200)
+READ_COUNTRY = FakedResponse(content=get_xml_file('R_read_country_list.xml'), status_code=200)
 READ_CSP = FakedResponse(content=get_xml_file('R_read_csp_list.xml'), status_code=200)
 READ_DIETCODE = FakedResponse(content=get_xml_file('R_read_dietcode_list.xml'), status_code=200)
 READ_ORGAN = FakedResponse(content=get_xml_file('R_read_organ_list.xml'), status_code=200)
 READ_PAI = FakedResponse(content=get_xml_file('R_read_pai_list.xml'), status_code=200)
 READ_QUALITIES = FakedResponse(content=get_xml_file('R_read_quality_list.xml'), status_code=200)
 READ_QUOTIENT = FakedResponse(content=get_xml_file('R_read_quotient_list.xml'), status_code=200)
 READ_SITUATIONS = FakedResponse(content=get_xml_file('R_read_situation_list.xml'), status_code=200)
+READ_STREET = FakedResponse(content=get_xml_file('R_read_street_list.xml'), status_code=200)
 READ_VACCIN = FakedResponse(content=get_xml_file('R_read_vaccin_list.xml'), status_code=200)
 IS_RL_EXISTS_TRUE = FakedResponse(content=get_xml_file('R_is_rl_exists.xml') % b'true', status_code=200)
 IS_RL_EXISTS_FALSE = FakedResponse(content=get_xml_file('R_is_rl_exists.xml') % b'false', status_code=200)
 IS_CHILD_EXISTS_TRUE = FakedResponse(content=get_xml_file('R_is_child_exists.xml') % b'true', status_code=200)
 IS_CHILD_EXISTS_FALSE = FakedResponse(
     content=get_xml_file('R_is_child_exists.xml') % b'false', status_code=200
 )
 CREATE_FAMILY = FakedResponse(content=get_xml_file('R_create_family.xml'), status_code=200)
@@ -308,16 +310,33 @@ def test_read_category_list(mocked_post, mocked_get, con, app):
     assert resp.json['err'] == 0
     assert resp.json['data'] == [
         {'id': 'BI', 'text': 'BIPARENTALE'},
         {'id': 'ACCEUI', 'text': "FAMILLE D'ACCUEIL"},
         {'id': 'MONO', 'text': 'MONOPARENTALE'},
     ]
 
 
+@mock.patch('passerelle.utils.Request.get')
+@mock.patch('passerelle.utils.Request.post')
+def test_read_country_list(mocked_post, mocked_get, con, app):
+    mocked_get.return_value = FAMILY_SERVICE_WSDL
+    mocked_post.return_value = READ_COUNTRY
+    url = get_endpoint('read-country-list')
+
+    resp = app.get(url)
+    assert resp.json['err'] == 0
+    assert len(resp.json['data']) == 3
+    assert resp.json['data'] == [
+        {'id': '212', 'text': 'AFGHANISTAN'},
+        {'id': '99303', 'text': 'AFRIQUE DU SUD'},
+        {'id': '99125', 'text': 'ALBANIE'},
+    ]
+
+
 @mock.patch('passerelle.utils.Request.get')
 @mock.patch('passerelle.utils.Request.post')
 def test_read_civility_list(mocked_post, mocked_get, con, app):
     mocked_get.return_value = FAMILY_SERVICE_WSDL
     mocked_post.return_value = READ_CIVILITIES
     url = get_endpoint('read-civility-list')
 
     resp = app.get(url)
@@ -514,16 +533,33 @@ def test_read_situation_list(mocked_post, mocked_get, con, app):
         {'id': 'P', 'text': 'Pacsé (e)'},
         {'id': 'S', 'text': 'Séparé (e)'},
         {'id': 'UL', 'text': 'UNION LIBRE'},
         {'id': 'V', 'text': 'Veuf (ve)'},
         {'id': 'VM', 'text': 'Vivant maritalement'},
     ]
 
 
+@mock.patch('passerelle.utils.Request.get')
+@mock.patch('passerelle.utils.Request.post')
+def test_read_street_list(mocked_post, mocked_get, con, app):
+    mocked_get.return_value = FAMILY_SERVICE_WSDL
+    mocked_post.return_value = READ_STREET
+    url = get_endpoint('read-street-list')
+
+    resp = app.get(url)
+    assert resp.json['err'] == 0
+    assert len(resp.json['data']) == 3
+    assert resp.json['data'] == [
+        {'id': 'AS0264', 'text': 'RUE SAINT FRANCOIS DE PAULE'},
+        {'id': 'AP0594', 'text': 'AVENUE PAULIANI'},
+        {'id': 'AM0330', 'text': 'TRAVERSE DES MARAICHERS'},
+    ]
+
+
 @mock.patch('passerelle.utils.Request.get')
 @mock.patch('passerelle.utils.Request.post')
 def test_read_vaccin_list(mocked_post, mocked_get, con, app):
     mocked_get.return_value = FAMILY_SERVICE_WSDL
     mocked_post.return_value = READ_VACCIN
     url = get_endpoint('read-vaccin-list')
 
     resp = app.get(url)
-- 
2.30.2

